%define _disable_ld_no_undefined 1

%define gsver 9.14
%define ijsver 0.35
%define ijsreloffset 100
%define ijsrel %(echo $((%{release} + %{ijsreloffset})))

%define ijsmajor 1
%define libijs %mklibname ijs %{ijsmajor}
%define libijs_devel %mklibname -d ijs

%define gsmajor 9
%define libgs %mklibname gs %{gsmajor}
%define libgs_devel %mklibname -d gs

%define bootstrap 0

%define GSx11SVGAmodule 1
%define withcupsfilters 0
%define debug 0
%if %{bootstrap}
%global withcupsfilters 0
%endif

Summary:	PostScript/PDF interpreter and renderer (Main executable)
Name:		ghostscript
Version:	%{gsver}
Release:	8
License:	GPLv2+
Group:		Publishing
Url:		http://www.ghostscript.com/awki/Index
Source0:	http://ghostscript.com/releases/%{name}-%{gsver}.tar.gz
Source2:	ps2pdfpress.bz2
Source3:	http://www.linuxprinting.org/download/printing/sipixa6.upp.bz2
Source4:	ghostscript.rpmlintrc

# Fedora patches
Patch1:		ghostscript-multilib.patch
Patch2:		ghostscript-scripts.patch
Patch3:		ghostscript-noopt.patch
Patch4:		ghostscript-runlibfileifexists.patch
Patch5:		ghostscript-icc-missing-check.patch
Patch6:		ghostscript-Fontmap.local.patch
Patch7:		ghostscript-iccprofiles-initdir.patch
Patch8:		ghostscript-gdevcups-debug-uninit.patch
Patch9:		ghostscript-wrf-snprintf.patch
Patch10:	ghostscript-9.14-system-zlib.patch

%if !%{bootstrap}
BuildRequires:	cups-devel
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(gtk+-2.0)
%endif
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	libtool
BuildRequires:	poppler-data
BuildRequires:	unzip
BuildRequires:	gettext-devel
BuildRequires:	glibc-devel
BuildRequires:	jbig2dec-devel
BuildRequires:	jpeg-devel
BuildRequires:	libpaper-devel
BuildRequires:	netpbm-devel
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(ice)
BuildRequires:	pkgconfig(jasper)
BuildRequires:	pkgconfig(lcms2)
BuildRequires:	pkgconfig(libidn)
BuildRequires:	pkgconfig(libopenjpeg1)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	pkgconfig(sm)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xext)
BuildRequires:	pkgconfig(xt)
BuildRequires:	pkgconfig(zlib)

Requires:	ghostscript-common
Requires:	ghostscript-fonts
Requires:	poppler-data
Requires:	update-alternatives
Requires:	urw-fonts
%if !%{GSx11SVGAmodule}
%rename	ghostscript-module-X ghostscript-module-SVGALIB
%endif

%description
Ghostscript is a set of software tools that provide a PostScript(TM)
interpreter, a set of C procedures (the Ghostscript library, which
implements the graphics capabilities in the PostScript language) and
an interpreter for Portable Document Format (PDF) files. Ghostscript
translates PostScript code into many common, bitmapped and vector
formats, like those understood by your printer or screen. Ghostscript
is normally used to display PostScript files and to print PostScript
files to non-PostScript printers.

You should install ghostscript if you need to display PostScript or
PDF files, or if you have a non-PostScript printer.

%files
%{_bindir}/gsc
%{_bindir}/gs-common
%{_bindir}/ghostscript

%preun
if [ "$1" = 0 ]; then
  # Remove update-alternatives entry
  %{_sbindir}/update-alternatives --remove gs %{_bindir}/gsc
fi

%post
# Set up update-alternatives entries
%{_sbindir}/update-alternatives --install %{_bindir}/gs gs %{_bindir}/gsc 200

#----------------------------------------------------------------------------

%package dvipdf
Summary:	PostScript/PDF interpreter and renderer (DVI-to-PDF converter)
Group: 		Publishing
Requires: 	ghostscript
Requires:	coreutils
Requires:	tetex-dvips

%description dvipdf
Tool to convert the DVI format of TeX into the PDF format. There are
more such tools (for different quality levels) in the tetex-dvipdfm
package. All these tools use dvips of TeX to convert the DVI file to
PostScript, then they use GhostScript to generate the PDF file.

%files dvipdf
%{_bindir}/dvipdf

#----------------------------------------------------------------------------

%package common
Summary:	PostScript/PDF interpreter and renderer (Common files)
Group: 		Publishing
Requires:	urw-fonts >= 1.1
Requires:	ghostscript-fonts
Requires:	perl

%description common
Ghostscript is a PostScript/PDF interpreter. It can render both
PostScript and PDF files to devices which include X window, many
printer formats, and popular graphics file formats.

This package contains the common data files needed by GhostScript.

%files common
%dir %{_datadir}/ghostscript
%{_datadir}/ghostscript/%{gsver}
%{_mandir}/man1/*
%lang(de) %{_mandir}/de/man1/*
%{_bindir}/[e-f]*
#{_bindir}/gs-common
%{_bindir}/gs[a-b]*
%{_bindir}/gs[d-n]*
%{_bindir}/[j-l]*
%{_bindir}/[n-z]*
%if %{withcupsfilters}
# "pstoraster" wrapper script to make GhostScript being used as the
# cups-internal RIP
%attr(0755,root,root) %{_prefix}/lib*/cups/filter/*
%{_datadir}/cups/model/*
%config(noreplace) %{_sysconfdir}/cups/gstoraster.convs
%endif

%post common
# Initialize japanese fonts
if test -f /usr/share/fonts/ttf/japanese/cidinst; then
    sh /usr/share/fonts/ttf/japanese/cidinst
fi

#----------------------------------------------------------------------------

%package X
Summary:	PostScript/PDF interpreter and renderer (GTK-based executable)
Group: 		Publishing
Requires: 	ghostscript-common
Requires:	update-alternatives

%description X
Ghostscript is a PostScript/PDF interpreter. It can render both
PostScript and PDF files to devices which include X window, many
printer formats, and popular graphics file formats.

This package contains a GhostScript executable with GTK-based X
display support ("display" device, default, so it displays files by
simply entering "gs <file>" on the command line). It makes use of the
GhostScript shared library.

%files X
%{_bindir}/gsx

%preun X
if [ "$1" = 0 ]; then
  # Remove update-alternatives entry
  %{_sbindir}/update-alternatives --remove gs %{_bindir}/gsx
fi

%post X
# Set up update-alternatives entries
%{_sbindir}/update-alternatives --install %{_bindir}/gs gs %{_bindir}/gsx 100

#----------------------------------------------------------------------------

%if %{GSx11SVGAmodule}
%package module-X
Summary:	PostScript/PDF interpreter and renderer (Additional support for X)
Group: 		Publishing
Requires: 	ghostscript-common

%description module-X
Ghostscript is a PostScript/PDF interpreter. It can render both
PostScript and PDF files to devices which include X window, many
printer formats, and popular graphics file formats.

This package enhances Ghostscript with X window support.

%files module-X
%doc README.shared.mandrivalinux
%dir %{_libdir}/ghostscript/%{gsver}
%{_libdir}/ghostscript/%{gsver}/X11.so
%endif

#----------------------------------------------------------------------------

%package -n %{libgs}
Summary:	PostScript/PDF interpreter and renderer (GhostScript shared library)
Group:		Publishing

%description -n %{libgs}
This is the API library for programs which use the PostScript and/or
PDF interpreters of GhostScript.

%files -n %{libgs}
%{_libdir}/libgs.so.*%{gsmajor}*

#----------------------------------------------------------------------------

%package -n %{libgs_devel}
Summary:	Headers and links to compile against the "%{libgs}" library
Group:		Development/C
Requires:	%{libgs} >= %{gsver}
Provides:	%{name}-devel = %{gsver}
Provides:	libgs-devel = %{gsver}
Obsoletes:	%{_lib}gs9-devel < %{gsver}
Obsoletes:	%{_lib}gs8-devel < %{gsver}

%description -n %{libgs_devel}
This package contains the static library and the header files needed
to compile applications using the GhostScript shared library.

%files -n %{libgs_devel}
%{_libdir}/libgs.so
%{_includedir}/ghostscript

#----------------------------------------------------------------------------

%package -n %{libijs}
Summary:	Dynamic library for the IJS printer driver plug-in interface
Version:	%{ijsver}
Release:	%{ijsrel}
Group:		Publishing
Url:		http://www.linuxprinting.org/ijs/
Provides:	libijs = %{ijsver}-%{ijsrel}

%description -n %{libijs}
This is the API library for programs using the IJS printer driver
plug-in interface. Printer drivers using this interface can be added
to GhostScript (6.53 or newer) without needing to rebuild
GhostScript. Application programs providing an IJS interface can make
use of IJS printer drivers directly, without needing GhostScript.

%files -n %{libijs}
%{_libdir}/libijs-%{ijsver}.so

#----------------------------------------------------------------------------

%package -n %{libijs_devel}
Summary:	Headers and links for compiling against the "%{libijs}" library
Version:	%{ijsver}
Release:	%{ijsrel}
Group:		Development/C
Url:		http://www.linuxprinting.org/ijs/
Requires:	%{libijs} >= %{ijsver}
Requires:	multiarch-utils
Provides:	libijs-devel = %{ijsver}-%{ijsrel}
Provides:	ijs-devel = %{ijsver}-%{ijsrel}
Obsoletes:	%{_lib}ijs1-devel < %{ijsver}-%{ijsrel}

%description -n %{libijs_devel}
This package contains the static library and the header files needed
to compile applications using the IJS library.

%files -n %{libijs_devel}
%doc ijs/README
%{_libdir}/libijs.so
%{_libdir}/pkgconfig/ijs.pc
%{_includedir}/ijs
%{_bindir}/ijs_client_example
%{_bindir}/ijs_server_example
%{_bindir}/ijs-config

#----------------------------------------------------------------------------

%package doc
Summary:	Documentation for GhostScript
Group:		Publishing

%description doc
This package contains documentation for GhostScript.

%files doc
%doc %{_docdir}/ghostscript-doc-%{gsver}

#----------------------------------------------------------------------------

%prep
%setup -q
%apply_patches

# prevent building and using bundled libs
rm -rf jasper jbig2dec libpng jpeg tiff expat zlib lcms freetype

# Convert manual pages to UTF-8
from8859_1() {
        iconv -f iso-8859-1 -t utf-8 < "$1" > "${1}_"
        mv "${1}_" "$1"
}
for i in man/de/*.1; do from8859_1 "$i"; done

# Stuff for shared library support to ghostscript.
%if %{GSx11SVGAmodule}
# build a small README describing the features available.
cat <<EOF >README.shared.mandrivalinux
This version of ghostscript support shared modules dynamically loaded
at run time.

There are currently two modules compiled with the Mandriva Linux version of
ghostscript, one to support all X11 devices (typically used by gv) and
another to support the svgalib devices. Look at the
ghostscript-module-??? packages.

There is no configuration needed, just can add (or remove) the package
to add (or remove) the devices concerned in ghostscript.
EOF
%endif

# ps2pdfpress
bzcat %{SOURCE2} > ps2pdfpress

# UPP file for SiPix Pocket Printer A6
bzcat %{SOURCE3} > sipixa6.upp

%build
EXTRACFLAGS="-fno-strict-aliasing"

pushd ijs*
./autogen.sh
%configure2_5x \
%ifarch %{ix86}
	--disable-sse2 \
%endif
	--enable-shared \
	--disable-static

%make
popd

FONTPATH=
for path in \
        %{_datadir}/fonts/default/%{name} \
        %{_datadir}/fonts/default/Type1 \
        %{_datadir}/fonts/default/amspsfnt/pfb \
        %{_datadir}/fonts/default/cmpsfont/pfb \
        %{_datadir}/fonts \
        %{_datadir}/%{name}/conf.d \
        %{_sysconfdir}/%{name} \
        %{_sysconfdir}/%{name}/%{gs_dot_ver} \
        %{_datadir}/poppler/cMap/*
do
  FONTPATH="$FONTPATH${FONTPATH:+:}$path"
done
autoconf --force

%configure2_5x \
	--enable-dynamic \
%if !%{bootstrap}
    --enable-fontconfig \
%endif
    --with-drivers=ALL \
    --with-fontpath="$FONTPATH" \
    --with-ijs \
    --with-x \
    --disable-compile-inits \
    --with-system-libtiff \
%if %{withcupsfilters}
    --with-install-cups \
%endif
	CFLAGS="$CFLAGS $EXTRACFLAGS"


# Drivers which do not compile:
# Needs newsiop/lbp.h: nwp533
# Needs sys/ioccom.h: sparc
# Needs unbdev/lpviio.h: sparc

# Set documentation dir
perl -p -i -e 's|^(docdir=).*$|$1\$\(datadir\)/doc/%{name}-doc-%{gsver}|' Makefile

# Fix references to X11 libraries
perl -p -i -e "s|(/usr/X11R6)/lib\b|\1/%{_lib}|g" Makefile base/*.mak

# Correct paths for CJK fonts
perl -p -i -e "s:/usr/share/ghostscript/:/usr/share/ghostscript/Resource/:g" Resource/Init/gs_res.ps
perl -p -i -e "s:ghostscript/Resource/fonts:ghostscript/Resource/Font:g" Resource/Init/gs_res.ps

# Do not use "-ansi" in gcc calls
perl -p -i -e "s:-ansi::g" Makefile

# bork
perl -p -i -e "s|^EXTRALIBS=|EXTRALIBS=-L/%{_lib} -lz |g" Makefile

# The RPM macro for make is not used here, as parallelization of the build 
# process does not work.
%if %{GSx11SVGAmodule}
#make STDDIRS
make obj/X11.so
%endif
make so
#make pcl3opts
make cups

%install
# Make directories
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_sysconfdir}
install -d %{buildroot}%{_mandir}/man1
%if !%{bootstrap}
install -d %{buildroot}%{_prefix}/lib/cups
install -d %{buildroot}%{_datadir}/cups/model
install -d %{buildroot}%{_sysconfdir}/cups
%endif

pushd ijs*
%configure2_5x \
	--enable-shared \
	--prefix=%{buildroot}%{_prefix} \
	--libdir=%{buildroot}%{_libdir}

# Work around bug in "configure" script
perl -p -i -e 's/\@OBJEXT\@/o/g' Makefile
perl -p -i -e 's/\@EXEEXT\@//g' Makefile
%makeinstall
# Fix prefixes in scripts
perl -p -i -e "s:%{buildroot}::g" %{buildroot}%{_bindir}/ijs-config
perl -p -i -e "s:%{buildroot}::g" %{buildroot}%{_libdir}/pkgconfig/ijs.pc
popd

##### GHOSTSCRIPT
mkdir -p %{buildroot}%{_docdir}/ghostscript-doc-%{gsver}

%if !%{bootstrap}
make \
	prefix=%{_prefix} \
	DESTDIR=%{buildroot} \
	gssharedir=%{_libdir}/ghostscript/%{gsver} \
	docdir=%{_docdir}/ghostscript-doc-%{gsver} \
	bindir=%{_bindir} \
%if %{withcupsfilters}
	install-cups \
%endif
	mandir=%{_mandir}
%endif

make \
	prefix=%{_prefix} \
	DESTDIR=%{buildroot} \
	gssharedir=%{_libdir}/ghostscript/%{gsver} \
	docdir=%{_docdir}/ghostscript-doc-%{gsver} \
	bindir=%{_bindir} \
	libdir=%{_libdir} \
	mandir=%{_mandir} \
	soinstall

%if %{GSx11SVGAmodule}
make \
	prefix=%{_prefix} \
	DESTDIR=%{buildroot} \
	gssharedir=%{_libdir}/ghostscript/%{gsver} \
	docdir=%{_docdir}/ghostscript-doc-%{gsver} \
	bindir=%{_bindir} \
	libdir=%{_libdir} \
	mandir=%{_mandir} \
	install-shared
%endif

ln -sf gs.1%{_extension} %{buildroot}%{_mandir}/man1/ghostscript.1%{_extension}

# ps2pdfpress
install -m 755 ps2pdfpress %{buildroot}%{_bindir}

# UPP file for SiPix Pocket Printer A6
install -m 644 sipixa6.upp %{buildroot}%{_datadir}/ghostscript/%{gsver}/lib/

# why?
%if %{withcupsfilters}
mv %{buildroot}%{_datadir}/cups/mime/gstoraster.convs %{buildroot}%{_sysconfdir}/cups/gstoraster.convs
%endif

# Add backward compatibility link to not break printerdrake in Mandriva
# 2006 and older
ln -s %{_bindir}/gsc %{buildroot}%{_bindir}/gs-common
ln -s %{_bindir}/gsc %{buildroot}%{_bindir}/ghostscript

# Correct permissions for all documentation files
chmod -R a+rX %{buildroot}%{_docdir}
chmod -R go-w %{buildroot}%{_docdir}
chmod -R u+w %{buildroot}%{_docdir}


%changelog

* Wed Apr 22 2015 Denis Silakov <denis.silakov@rosalab.ru> 9.14-8
- (629aa5a) Rebuild with new poppler


